package chat;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketTimeoutException;
import java.util.List;

import javax.swing.JTextArea;

class OutdoorListenerThread extends Thread {
	User user;
	JTextArea displayArea;
	JTextArea knownUsersPanel;
	List<User> known_users;
	List<User> known_outdoor_users;
	List<Socket> dest_sockets;
	List<Socket> outdoor_dest_sockets;
	int outdoorPortNumber;
	
OutdoorListenerThread(User in_user, List<User> in_known_users,  List<User> in_known_outdoor_users, List<Socket> in_dest_sockets, List<Socket> in_outdoor_dest_sockets,
			JTextArea in_displayArea, JTextArea in_knownUsersPanel)
	{
		user = in_user;
		known_users = in_known_users;
		known_outdoor_users = in_known_outdoor_users;
		dest_sockets = in_dest_sockets;
		outdoor_dest_sockets = in_outdoor_dest_sockets;
		displayArea = in_displayArea;
		knownUsersPanel = in_knownUsersPanel;
		outdoorPortNumber = 2344;
	}
	public void run()
	{
		boolean exit = false;
		boolean accepted = true;

		String username;
		String response = "";
		
		try
		{
			while(!exit)
			{
				try
				{
					ServerSocket servSocket = new ServerSocket(1233);
					System.out.println("Waiting for connection request");
					Socket link = servSocket.accept();
					BufferedReader in = new BufferedReader(new InputStreamReader(link.getInputStream()));
					PrintWriter out = new PrintWriter(link.getOutputStream(), true);
					username = in.readLine();
					System.out.println("Received a request from " + username + "@" + link.getRemoteSocketAddress().toString());
					
					response = "";
					for(User u:known_users)
					{
						response += u.getName() + " ";
					}
					response = response.trim();
					response += ";";
					for(User u:known_outdoor_users)
					{
						response += u.getName() + " ";
					}
					response = response.trim();
					response += ";" + (outdoorPortNumber+1);
					
					out.println(response);
					
					accepted = true;
					for(User a:known_users)
					{
						accepted = accepted && (!username.equals(a.getName()));
					}
					for(User a:known_outdoor_users)
					{
						accepted = accepted && (!username.equals(a.getName()));
					}
					if(accepted)
					{
						outdoorPortNumber++;
						Socket s = (new ServerSocket(outdoorPortNumber)).accept();
						(new ReceiveThread(user, s, displayArea, known_users, known_outdoor_users, knownUsersPanel, dest_sockets, outdoor_dest_sockets, true)).start();
			        	outdoor_dest_sockets.add(s);
					}
					servSocket.close();
				}
				catch(SocketTimeoutException e) {}
	    	}
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.out.println(e.getMessage());
		}
	}
}